class MMLocation
  require 'MMLatLon'
  require 'MMPoint'
  attr_accessor :address, :coords, :bounds, :search, :route, :zoom_factor, :geocode_quality, :geocode_score, :error_code

  def initialize( a = {} )
    if a.nil?
      return
    end
    if a[:address]
      self.address = a[:address]
    end
    if a[:coords]
      self.coords = a[:coords]
    end
    if a[:bounds]
      self.bounds = a[:bounds]
    end
    if a[:search]
      self.search = a[:search]
    end
    if a[:route]
      self.route = a[:route]
    end
    if a[:zoom_factor]
      self.zoom_factor = a[:zoom_factor]
    end
  end

  def to_json(*a)
    {                                                                                                                                                                                               
      "address" => self.address,
      "coords" => self.coords,
      "zoom_factor" => self.zoom_factor,
      "bounds" => self.bounds
    }.to_json(*a)
  end

  def to_s
    str = '{ address : '
    if self.address
      str += self.address.to_s
    else
      str += 'nil'
    end
    str += ', search : '
    if self.search
      str += self.search.to_s
    else
      str += 'nil'
    end
    str += ', coords : '
    if self.coords
      str += self.coords.to_s
    else
      str += 'nil'
    end
    str += ', zoom_factor : '
    str += self.zoom_factor.to_s
    str += ', bounds : '
    if self.bounds
      str += self.bounds.to_s
    else
      str += 'nil'
    end
    str += ' }'
    return str
  end

  def fromJSON( json )
    if json.nil?
      return
    end
    self.geocode_quality = json['geocode_quality']
    self.geocode_score = json['geocode_score']
    self.zoom_factor = json['zoom_factor'].to_i
    if json['address']
      self.address = MMAddress.new
      self.address.fromJSON(json['address'])
    end
    if json['point']
      self.coords = MMLatLon.new
      self.coords.fromJSON( json['point'] )
    end
    if json['bounds']
      self.bounds = MMBounds.new
      self.bounds.fromJSON(json['bounds'])
    end
  end

  def copy
    cp = MMLocation.new
    cp.zoom_factor = self.zoom_factor
    if self.address
      cp.address = self.address.copy
    end
    if self.coords
      cp.coords = self.coords.copy
    end
    if self.route
      cp.route = self.route.copy
    end
    if self.search
      cp.search = self.search.copy
    end
    if self.bounds
      cp.bounds = self.bounds.copy
    end
    return cp
  end
end
